VERSION 5.00
Begin VB.UserControl ctlblink 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Timer tmrblinker 
      Left            =   1200
      Top             =   1920
   End
   Begin VB.Label lblblink 
      Caption         =   "Label1"
      Height          =   495
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "ctlblink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'Default Property Values:
Const m_def_ForeColor1 = 0
Const m_def_ForeColor2 = 0
Const m_def_BackColor1 = 0
Const m_def_BackColor2 = 0
'Property Variables:
Dim m_ForeColor1 As OLE_COLOR
Dim m_ForeColor2 As OLE_COLOR
Dim m_BackColor1 As OLE_COLOR
Dim m_BackColor2 As OLE_COLOR

Dim usecolors1 As Boolean

'Event Declarations:
Event Blinked()

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
  Caption = lblblink.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
  lblblink.Caption() = New_Caption
  PropertyChanged "Caption"
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
  Set Font = lblblink.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
  Set lblblink.Font = New_Font
  PropertyChanged "Font"
End Property

Public Property Get ForeColor1() As OLE_COLOR
  ForeColor1 = m_ForeColor1
End Property

Public Property Let ForeColor1(ByVal New_ForeColor1 As OLE_COLOR)
  m_ForeColor1 = New_ForeColor1
  PropertyChanged "ForeColor1"
End Property

Public Property Get ForeColor2() As OLE_COLOR
  ForeColor2 = m_ForeColor2
End Property

Public Property Let ForeColor2(ByVal New_ForeColor2 As OLE_COLOR)
  m_ForeColor2 = New_ForeColor2
  PropertyChanged "ForeColor2"
End Property

Public Property Get BackColor1() As OLE_COLOR
  BackColor1 = m_BackColor1
End Property

Public Property Let BackColor1(ByVal New_BackColor1 As OLE_COLOR)
  m_BackColor1 = New_BackColor1
  PropertyChanged "BackColor1"
End Property

Public Property Get BackColor2() As OLE_COLOR
  BackColor2 = m_BackColor2
End Property

Public Property Let BackColor2(ByVal New_BackColor2 As OLE_COLOR)
  m_BackColor2 = New_BackColor2
  PropertyChanged "BackColor2"
End Property

Public Property Get Interval() As Long
Attribute Interval.VB_Description = "Returns/sets the number of milliseconds between calls to a Timer control's Timer event."
  Interval = tmrblinker.Interval
End Property

Public Property Let Interval(ByVal New_Interval As Long)
  tmrblinker.Interval() = New_Interval
  PropertyChanged "Interval"
End Property

Public Sub BlinkNow()
tmrblinker_Timer
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
  m_ForeColor1 = m_def_ForeColor1
  m_ForeColor2 = m_def_ForeColor2
  m_BackColor1 = m_def_BackColor1
  m_BackColor2 = m_def_BackColor2
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

  lblblink.Caption = PropBag.ReadProperty("Caption", "Label1")
  Set Font = PropBag.ReadProperty("Font", Ambient.Font)
  m_ForeColor1 = PropBag.ReadProperty("ForeColor1", m_def_ForeColor1)
  m_ForeColor2 = PropBag.ReadProperty("ForeColor2", m_def_ForeColor2)
  m_BackColor1 = PropBag.ReadProperty("BackColor1", m_def_BackColor1)
  m_BackColor2 = PropBag.ReadProperty("BackColor2", m_def_BackColor2)
  tmrblinker.Interval = PropBag.ReadProperty("Interval", 0)
End Sub

Private Sub UserControl_Resize()
lblblink.Width = Width
lblblink.Height = Height
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

  Call PropBag.WriteProperty("Caption", lblblink.Caption, "Label1")
  Call PropBag.WriteProperty("Font", Font, Ambient.Font)
  Call PropBag.WriteProperty("ForeColor1", m_ForeColor1, m_def_ForeColor1)
  Call PropBag.WriteProperty("ForeColor2", m_ForeColor2, m_def_ForeColor2)
  Call PropBag.WriteProperty("BackColor1", m_BackColor1, m_def_BackColor1)
  Call PropBag.WriteProperty("BackColor2", m_BackColor2, m_def_BackColor2)
  Call PropBag.WriteProperty("Interval", tmrblinker.Interval, 0)
End Sub

' This is the procedure that actually does the stuff!
' Everything else is property management
Private Sub tmrblinker_Timer()
  usecolors1 = Not usecolors1
  If usecolors1 Then
    lblblink.ForeColor = m_ForeColor1
    lblblink.BackColor = m_BackColor1
  Else
    lblblink.ForeColor = m_ForeColor2
    lblblink.BackColor = m_BackColor2
  End If
  
  RaiseEvent Blinked

End Sub


